open OUnit2
open Interp3

(* A few test cases *)
let tests = [
  "int"  >:: (fun _ -> assert_equal (Int 22) (interp (Int 22)));
  "add"  >:: (fun _ -> assert_equal (Int 22) (interp (Add(Int 11,Int 11))));
  "adds" >:: (fun _ -> assert_equal (Int 22) (interp (Add(Add(Int 10, Int 1),Add(Int 5, Int 6)))));
  "let"  >:: (fun _ -> assert_equal (Int 22) (interp (Let("x",TInt,Int 22,Var "x"))));
  "lets" >:: (fun _ -> assert_equal (Int 22) (interp (Let("x",TInt,Int 0,Let("x",TInt,Int 22,Var "x")))));
  "typerr1" >:: (fun _ -> assert_raises (Failure "Type error (let)") (fun () -> typecheck [] (Let("x",TBool,Int 22,Var "x"))));
  "typerr2" >:: (fun _ -> assert_raises (Failure "Type error (unbound variable)") (fun () -> typecheck [] (If(Int 22,Var "x",Var "y"))));
]

let _ = run_test_tt_main ("interp3 suite" >::: tests)

